/**
 * A hat.
 */
function HatScarf() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var itemName = "Green Hat/Scarf Combo";
    var itemDescription = "Clothing belonging to a dead person. The hat has a bloodspatter on it. The scarf is stained with something white. Cream, you hope. It smells faintly of peaches.";
    var baseValue = 15;
    var offensiveValue = 0;
    var defensiveValue = 1;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // ITEM-REQUIRED item-enum for construction purposes.
    this.id = ItemEnum.HATSCARF;
    // ITEM-REQUIRED type-enum for tooltip purposes.
    this.type = ItemTypeEnum.GEAR;
    // GEAR-REQUIRED slot-enum.
    this.slot = SlotEnum.HELMET;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the name of this item.
     * @param {boolean} caps Whether or not the name should be capitalized.
     * @returns {string} The name of this item.
     */
    this.name = function (caps) {
        var toReturn = caps ? itemName : itemName.toLowerCase();
        return toReturn;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the description of this item.
     * @returns {string} The description of this item.
     */
    this.description = function () {
        return itemDescription;
    };

    /**
     * ITEM-REQUIRED function.
     * Calculates and returns the price (= value) of this item.
     * @returns {int} The price of this pair of pants, in coins.
     */
    this.price = function () {
        return baseValue;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns a custom tooltip style for this item.
     * @returns {string} The custom style.
     */
    this.toolTipStyle = function () {
        return "width: 220px;";
    };

    /**
     * GEAR-REQUIRED function.
     * Calculates and returns the offensive value of this piece of gear.
     * @returns {int} The offensive value of this piece of gear.
     */
    this.offence = function () {
        return offensiveValue;
    };

    /**
     * GEAR-REQUIRED function.
     * Calculates and returns the defensive value of this piece of gear.
     * @returns {int} The defensive value of this piece of gear.
     */
    this.defence = function () {
        return defensiveValue;
    };

    /**
     * HELMET-required function.
     * Returns true if the helmet hides the kobold's face, false otherwise.
     * @returns {boolean} True if the helmet hides the kobold's face, false otherwise.
     */
    this.hidesFace = function () {
        return true;
    };

    /**
     * HELMET-required function.
     * Returns true if the helmet can be torn, false otherwise.
     * @returns {boolean} True if the helmet can be torn, false otherwise.
     */
    this.canBeTorn = function () {
        return true;
    };

    /**
     * HELMET-required function.
     * Returns true if the shoes are a mismatch for the kobold's current gender.
     * @returns {boolean} True if the shoes are a mismatch for the kobold's current gender, false otherwise.
     */
    this.wrongGender = function () {
        return false;
    };

    /**
     * ITEM-REQUIRED function.
     * Loads this object from a type-stripped version thereof.
     * @param {Helmet-stripped} helmet A Helmet object, stripped of private members and all functions.
     */
    this.load = function (helmet) {
        
    };
}
