/**
 * This class contains all the necessary functions to deal with the tabs section of the UI.
 * Its init() function should be called immediately upon successful project load.
 */
function AllMenuButtons() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var gen = new GenericMenuButton();

    // PRIVATE FUNCTIONS \\     function privateFunction(){}
    this.map = new MapMenuButton(gen);
    this.preview = new PreviewMenuButton(gen);
    this.settings = new SettingsMenuButton(gen);
    this.story = new StoryMenuButton(gen);
    this.fanart = new FanArtMenuButton(gen);
    this.charsheet = new CharSheetMenuButton(gen);
    this.contribute = new ContributeMenuButton(gen);

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Initializes all tabs.
     */
    this.init = function () {
        that.map.init();
        that.preview.init();
        that.settings.init();
        that.story.init();
        that.fanart.init();
        that.charsheet.init();
        that.contribute.init();
    };
    
    /**
     * Unsets all buttons.
     */
    this.unset = function () {
        that.map.unset();
        that.preview.unset();
        that.settings.unset();
        that.story.unset();
        that.fanart.unset();
        that.charsheet.unset();
        that.contribute.unset();
    };
}
