/**
 * This class contains generic functions shared across all throbbers.
 */
function GenericThrobber() {
    // PRIVATE MEMBERS \\       var private = "test";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Uses jQuery to show the element with the passed id.
     * @param {string} id The id of the element to show.
     */
    this.show = function (id) {
        var element = $("#" + id);
        element.stop(true);
        element.show(400);
    };

    /**
     * Uses jQuery to hide the element with the passed id.
     * @param {string} id The id of the element to show.
     */
    this.hide = function (id) {
        var element = $("#" + id);
        element.stop(true);
        element.hide(400);
    };
}
