/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDecline(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.DECLINE;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.dog;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Pee inside of you?
                            Heck no.
                            You're not going to let Falco do that!
                            Gathering all of your courage, you stand up for yourself, and [b]push[/b] him off of you!
                            You clearly tell the avian that he is [b]not[/b] going to [b]defile[/b] you like that.
                            This is [b]not[/b] proper behavior.
                            He's [b]drunk[b].
                            You're [b]pregnant[/b]!
                            And even if you weren't, you [b]still[/b] wouldn't allow him to [b]abuse[/b] your body like that!
                            You're [b]not[/b] a gosh-darn urinal!
                        [/p]
                        [p]
                            Your angry rant, spurred on by his apathetic stance to parenthood, seems to upset the bird.
                            And not in a good way.
                            He glares at you, with pure [b]hatred[/b] in his eyes.
                            Wordlessly advancing upon you once more,
                            the eagle brutishly [b]grabs[/b] the mop from your hands, wicked thoughts forming in his booze-addled mind.
                        [/p]
                        [p]
                            You [b]demand[/b] to know what he's doing, but there is no response.
                            Grabbing you by the arm, the boy forcibly bends you over a nearby dresser,
                            keeping you pinned down with surprising, alcohol-fueled strength.
                            You tell him to [b]stop[/b] and [b]think[/b] about what he's doing!
                            There'll be no going back after this!
                            No more him and you!
                        [/p]
                        [p]
                            But it's too late.
                            His mind is made up.
                            "[color=yellow]You became a [b]bitch[/b] ever shinsh you got pregnant.[/color]"
                            The avian leans in close, and whispers into your ear.
                            "[color=yellow][small]Time to fix that.[/small][/color]"
                            Before you can utter any more protests, Falco yanks your tail upwards,
                            and with his other hand, he wildly [b]shoves[/b] the wooden handle of your mop into your cunt,
                            as far as it will go and then some.
                        [/p]
                        [p]
                            You [b]scream[/b] out in pain as the splintery wood [b]rakes[/b] open your insides,
                            the blunt tip of the broom pushing [b]far[/b] deeper than [b]anything[/b] is supposed to go.
                            Your cervix is [b]rammed[/b] open,
                            and the excruciating torment of having a coarse foreign object [b]invade[/b] your very womb is enough for your mind to black out,
                            your eyes rolling into the back of your head out of sheer [b]torment[/b].
                            Your body lifelessly crumples to the floor, completely limp.
                        [/p]
                        [hl]
                        [p]
                            You wake up some time later.
                            You are lying on the floor, blood oozing from your slit,
                            the broom on the ground next to you, the handle painted red.
                            You clutch your aching belly, fearing the blood spilling from your loins isn't just [i]yours[/i].
                            Falco is nowhere to be seen.
                            You think he might have [b]killed[/b] your child.
                        [/p]
                        [p]
                            Your mind barely able to process the horror that was inflicted upon you,
                            you rise to your shaky feet.
                            Your loins hurt [b]so much[/b] you can barely stand.
                            But your traumatized mind ignores the pain.
                            Completely distraught,
                            you pick up the mop,
                            and begin to clean up the spilled guts of your unborn baby,
                            blood still trickling down your inner thighs.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
