/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfyFree(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkSatisfyDadChoice.LEAVE;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            No.
                            You can't accept that invitation.
                            You [i]want[/i] to stay here, with Falco,
                            but you just can't.
                            He'd get in trouble if people found out he was [i]seeing[/i] a kobold.
                            Especially in a narrow-minded community such as this one.
                            The past year, you've been chained to this house like a dog on a leash.
                            You've been kept here like a bird in a cage.
                            It's time for you to fly.
                            You hope he understands.
                        [/p]
                        [p]
                            Falco gives you a small, teary-eyed nod.
                            Hanging his head in defeat, having lost his father, his mother and now his lover all in a single day,
                            he silently strolls towards the backdoor.
                            After casting one final glance at you,
                            he vanishes into the home that you were kept in for over a year.
                            That's the last you ever see of him.
                        [/p]
                        [p]
                            You head for Varanar.
                            With no money, no place to stay, a baby on the way and no clothing but your skimpy maid outfit,
                            you end up sleeping in the streets more than once.
                            You stop by Seki's place, but the old bird must have moved away or something.
                            His house is abandoned.
                            You try to find a legitimate job, but nobody wants to hire a kobold, let alone a pregnant one.
                        [/p]
                        [p]
                            Eventually, thanks to your maid costume, you manage to get a job at a sleazy inn, cleaning rooms.
                            You get harassed by many clients, but none go beyond touching you a little.
                            Still having nowhere to sleep, you spend your nights in various alleyways.
                            A few weeks later, at night, you give birth to your child.
                            A healthy kobold baby boy.
                            You press him close to you, to keep him warm throughout the cold night.
                        [/p]
                        [p]
                            In the morning, you return to your workplace to find it closed.
                            City guards raided the place, found a bunch of stolen weapons, drugs and other illicit properties in the basement.
                            Out of work, on your first day as a mother.
                            Off to a good start.
                        [/p]
                        [p]
                            You frantically look, but fail to find anywhere else to work.
                            While hiring a [i]pregnant[/i] kobold is taboo,
                            hiring a kobold with a day-old child is even less accepted.
                            You get chased out of several places for even [b]daring[/b] to ask if they could consider employing you.
                            After not getting anything to eat for over a week, you turn to begging.
                        [/p]
                        [p]
                            A year of living on the street goes by.
                            You beg for scraps, for coins and for people [i]not[/i] to beat you.
                            Sometimes you manage to scrounge up enough money to buy a bit of bread to feed you and your growing child.
                            Other times, you starve for days on end.
                            Despite the constant persecution you face,
                            your son seems to be growing up alright.
                            The two of you are kobolds.
                            Your species is used to this.
                            You'll get through it.
                            There's always a light at the end of the tunnel.
                        [/p]
                        [p]
                            One fateful evening, you walk into the wrong alleyway.
                            A human gang runs this part of town, and they're [b]not[/b] happy to see you.
                            Broadly built men block both exitways.
                            You put your child on the ground.
                            As the humans advance on you, you tell your little boy to [b]run[/b].
                            He barely gets away without being caught,
                            his tiny size allowing him to squeeze in between the legs of one of the thugs.
                            You are not so lucky.
                        [/p]
                        [p]
                            Your offspring watches from the edge of the alleyway,
                            as the lowlifes violently have their way with you,
                            brutally beating you senseless while violating every part of your body.
                            You are beaten, you are raped, you are choked, you are pissed on,
                            you are dragged through the mud, and finally, after every last man has tormented you in his own way,
                            the leader of the gang viciously snaps your neck, ending your miserable life.
                        [/p]
                        [p]
                            Your son, barely able to keep quiet while watching his mother get beaten to death,
                            bursts out into tears.
                            He mindlessly runs throughout the city until dawn.
                            Growing hungry, he does the only thing you taught him to do:
                            he begs.
                        [/p]
                        [p]
                            Years later, after a chance encounter with a kind-hearted avian,
                            the boy decides to leave the city, and live his life free of harassment,
                            in the surrounding woods.
                            There, he finds a shack, abandoned for many years.
                            His new home.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Full circle end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}
