/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfyStay(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkSatisfyDadChoice.STAY;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Yes.
                            You accept.
                            You want to stay here, with Falco.
                            You want to raise your child together,
                            and you want to grow old with him.
                            You...you love him.
                            His eyes light up at that last part.
                        [/p]
                        [p]
                            "[color=yellow]I...I...[/color]" he can't find the words to express himself with.
                            How cute.
                            You press your muzzle against his beak, and give him a single, tender kiss.
                            He lets out a happy sigh, and takes your hand.
                            "[color=yellow]I'll work the farm, from now on.
                            Keep us both fed.
                            Maybe see if there's some carpentry tools in the shed,
                            so I can build [b]our[/b] baby a crib.[/color]"
                        [/p]
                        [p]
                            His words fill your heart with joy.
                            [b]Our[/b] baby.
                            You like the sound of that.
                            "[color=yellow]Let's get inside.
                            It's starting to get cold.
                            I bet it'll be far warmer in bed.[/color]"
                            Falco winks.
                            You gladly agree.
                        [/p]
                        [p]
                            Hand in hand, you walk back to the house.
                            Right before you enter the door,
                            the bird [b]lifts[/b] you off the ground.
                            Like a princess after her wedding,
                            he carries you inside, up the stairs, and into his bedroom.
                            The two of you make passionate love althroughout the night.
                        [/p]
                        [p]
                            Thus begins your life as the eagle's wife.
                            You live a meagre existence, without much luxury,
                            but you are happy, and so is he.
                            He makes sure there's always plenty of food to go around,
                            and he really does end up building that crib,
                            just in time for the birth of your baby.
                            A healthy boy.
                            Crossbreed, avian and kobold.
                            A feathery lizard.
                            [b]Your[/b] feathery lizard.
                        [/p]
                        [com]
                        [p]
                            You love and care for your child all day long,
                            while your unmarried husband works his ass off to keep you fed, clothed and out of harm's way.
                            At the end of the day, you warmly welcome him home,
                            
                        [/p]
                        [/com]
                        [p]
                            [c]
                                [b]
                                    Dinosaur end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}
