/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriend(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.girlfriend;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendJealous(ctrl);
    var secondNext = new FarmerMaidGirlfriendAccept(ctrl);

    var firstChoice = FarmerMaidGirlfriendChoice.JEALOUS;
    var secondChoice = FarmerMaidGirlfriendChoice.ACCEPT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var frigid = ctrl.maid.get() === FarmerMaidMaidChoice.RESIST;
        var eager = ctrl.maid.get() === FarmerMaidMaidChoice.ABIDE;
        var hand = ctrl.parents.get() === ctrl.parentsChoice.HANDJOB;
        var toReturn = `[p]
                            For more than a year,
                            life continues as usual.
                            You clean, Romeo works, Juliet shops, and Romeo fucks his bride-to-be day-in, day-out.
                            It's a miracle she hasn't gotten pregnant yet,
                            but that's none of your concern.
                        [/p]
                        [p]
                            In Spring of your second year as the family's maid,
                            the farmer makes a sudden announcement.
                            He is [b]retiring[/b].
                            Harvest has been [b]so[/b] good these past couple of seasons,
                            that he's earned enough money to buy him and his wife a fancy house in the city,
                            where he can live the rest of his life in peace and luxury, especially compared to this [i]dump[/i].
                        [/p]
                        [p]
                            The eagle is excited, thinking his girlfriend and him could tag along, but alas, that was not in his father's plans.
                            The older human thinks it's time for his son to live on his own.
                            He grants Falco sole ownership over the farm, the house, and over [b]you[/b].
                            Despite protests from both you and the the coddled avian,
                            Romeo's mind is made up.
                            The next week, Julia and him move out of the house, leaving you all alone with the bird and his lover.
                        [/p]
                        [p]
                            Luckily, not much changes for you.
                            Falco spends most days on the field, growing crops for his girl and him to eat.
                            You get scraps of food, in return for keeping the house clean.
                            For the rest, he doesn't really bother you.
                            When he's not working, he's too busy fucking his human partner to pay you much mind.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Grow jealous</button>`;

        var tooltip = global.parser.parse(`Why should that bitch get to hog the bird all to herself?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 195px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled} style="width:180px;">Accept your place</button>`;

        var tooltip = global.parser.parse(`Being a maid without getting harassed all the time has its perks.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 165px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width:180px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendChoice = {
    JEALOUS: 1,
    ACCEPT: 2
};
