/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidEncourage(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.ENCOURAGE;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAmorous(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            So, the boy is [i]interested[/i] in your body, huh?
                            Scolding him for being curious would be awfully rude of you,
                            not to mention kind of [i]hypocritical[/i].
                            Instead, you decide to give him a little [i]show[/i].
                            Something he will [b]never[/b] forget.
                        [/p]
                        [p]
                            You turn around, the avian removing his hands from your bosom, clearly thinking you're about to tell him off.
                            His face turns to shock, when instead of angrily reprimanding him,
                            you promptly tug down your maid dress, showing your naked tits to the eagle.
                            His eyes go wider still, as you take his hand, and place it upon your bare breast-scales,
                            giving him a reaffirming nod in the process.
                        [/p]
                        [p]
                            Falco eagerly rubs and squeezes your chest, his second hand joining in on the fun.
                            His inexperience is kind of [i]endearing[/i].
                            You only barely manage to suppress your excitement, as he [b]squeezes[/b] one of your nipples.
                            It's like he's never seen a pair of breasts before in his life.
                            Juliet must not have wanted to breastfeed him.
                            You don't blame her -- he [b]does[/b] have a beak, after all.
                        [/p]
                        [p]
                            Speak of the devil, both you and your new avian friend gasp in surprise,
                            as your notice the front door being fiddled with.
                            You instantly fix your dress, and return to cleaning.
                            The bird, panicking, flees up the stairs.
                            Through the front door walks his mother,
                            home from shopping for foodstuffs in Varanar.
                        [/p]
                        [p]
                            She greets you, and with a flushed look on your face, you welcome her home.
                            She suspiciously stares at you for a few tense moments.
                            Shrugging, the woman asks you to help her carry the goods she brought him to the kitchen.
                            And so, your life as a maid resumes.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
