/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidResist(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.RESIST;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAbusive(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            No.
                            You sternly [b]slap[/b] the boy's hands off of your chest.
                            Turning around, you push him away from you.
                            "[color=yellow]Hey!
                            You're my [b]slave[/b].
                            You can't push me away like that!
                            Want me to go tell my dad you're being [b]rude[/b] to me?[/color]"
                        [/p]
                        [p]
                            You kindly inform the avian that you are [b]not[/b] his slave.
                            You are his [b]father[/b]'s slave, and his [b]maid[/b].
                            You clearly remember the human saying, on the day you were bought, that you are [b]not[/b] a pet.
                            His ogling, you permitted, because it didn't really bother you too much, but this time, he took things too far.
                            If anything, [b]you[/b] should be the one telling Romeo about what happened here.
                        [/p]
                        [p]
                            While you are still not used to talking without teeth, you think you got the point across.
                            Your words clearly upset the avian.
                            He glares at you with an intense hatred in his beady eyes.
                            For a moment, he raises his hand, as though he's about to strike you,
                            yet he manages to refrain.
                            Instead of knocking some sense into you,
                            the bird angrily storms out of the door.
                            That is the last you see of him that day.
                        [/p]
                        [p]
                            The day after, Falco is no longer around to ogle you.
                            In fact, you never witnessed him emerging from the dining room after breakfast.
                            He must have left through the back door.
                            After finishing your duties in the den,
                            you swing open the kitchen door,
                            and stumble upon something you wish you hadn't seen.
                        [/p]
                        [p]
                            The eagle is bending his human mother over the countertop,
                            one of his hands wantonly groping her shirt-covered chest,
                            while he grinds his bulging member against her shapely behind.
                            He doesn't even stop when he notices you,
                            instead shooting a wicked smile your way,
                            pinching Juliet's nipple to make her [b]squeal[/b].
                        [/p]
                        [p]
                            For a moment, you look on in shock,
                            your brain refusing to believe what your eyes are seeing.
                            The boy gives his mother an explicit [b]hump[/b],
                            rubbing his groin against hers,
                            rocking her body back and forth along the countertop.
                            Unsure of how to react, you are frozen in place for a few seconds more.
                            Then, you awkwardly back away,
                            and close the kitchen door like you were never even there,
                            leaving the two to their privacy.
                        [/p]
                        [p]
                            Your heart is racing.
                            Falco molesting his mother?!
                            You wonder if he's doing this because you denied him,
                            or if this was an ongoing thing that you only just now stumbled upon?
                            She didn't seem too happy about it,
                            but she wasn't resisting his grasp either.
                            She could have easily thrown him off if she wanted to.
                        [/p]
                        [p]
                            You briefly wonder whether or not you should [i]intervene[/i],
                            or perhaps tell Romeo about what's happening,
                            but you'd rather not poke that hornet's nest.
                            This is between Juliet and her son.
                            A familial affair.
                            It would be rude of you to butt in.
                            You're a slave, not a relationship counselor.
                            It's none of your business.
                            So you act like you saw nothing.
                            Like everything is [b]fine[/b].
                            Ignoring the events unfolding in the kitchen, you head upstairs and clean the family's rooms.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
