/**
 * Bite section of the unknown scene.
 * @param {ForestController} controller The forest controller.
 */
function ForestUnknownBite(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = `biteContinueButton`;
    var next = new ForestUnknownBiteContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            No.
                            While the urge to simply open your mouth and experience the taste of whatever sap the plant is spewing forth is great, you [b]don't[/b] give in.
                            You may not be the smartest of kobolds, but you know enough to realize that randomly tasting unknown substances is [b]bad[/b] for your health.
                            At best, it may simply be an alluring means to get you to suck the tentacle off.
                            At worst, it's [b]acid[/b] intended to [b]melt your insides[/b] so the monster can [b]eat[/b] you.
                        [/p]
                        [p]
                            The tendril's incessant attempts to get past your lips intensify.
                            It pushes and it prods and it presses against your sealed teeth, yet you [b]refuse[/b] to let it into your mouth.
                            Your brain, despite being addled by the strong, 
                            intoxicating scent which continues to build up as the tentacle slathers your lips with more of its syrup,
                            is working overtime to try and find a way out of this situation.
                        [/p]
                        [p]
                            You tentatively wriggle your limbs about, but any which way you move just ends up with your scales pressing against prickly thorns.
                            Your tail is the only part of yours that [i]isn't[/i] restrained, but unlike your claws, it isn't capable of slicing through vines.
                            You need something sharp.
                            Something that can cut through the plant's appendages.
                            Then it hits you.
                            Your teeth.
                        [/p]
                        [p]
                            You can [b]bite[/b] the plant, and sever its tendrils that way.
                            But then again, you can't reach any of them, barring the one pressing against your mouth.
                            In a way, the smooth tentacle seems far more [i]delicate[/i] than the thorny ones.
                            You wonder, could it perhaps be akin to the monster's genitals?
                            If so, [b]biting[/b] it [i]might[/i] prove painful enough to stun the creature, or perhaps even to knock it out cold.
                            If it feels pain in the first place, that is.
                            If it doesn't, it might just squeeze you [b]to death[/b].
                            But you'd rather die than get forced to suck off a plant anyway.
                        [/p]
                        [p]
                            Slowly, you open up your mouth, spreading your teeth and your lips both.
                            The impatient tendril immmediately finds its way into your mouth.
                            Then, before it has a chance to dull your senses with its potent honey, you brutally [b]chomp[/b] down,
                            your teeth sinking into the surprisingly flesh-like innards of the tentacle.
                            You pull your head to the side, practically [b]ripping[/b] off the small bit of the tender plant-part that had made it past your lips,
                            before immediately spitting out the chewed-off piece once more, fearing the effects of the sap that spews from its innards.
                        [/p]
                        [p]
                            The very instant you bite down, the entire organic terror recoils, 
                            its tendrils rapidly unfurling from your limbs, slinking back to the central mass.
                            The tentacle you bit falls lifelessly to the ground.
                            It can [b]definitely[/b] feel [b]pain[/b].
                        [/p]
                        [p]
                            With your hands freed, you quickly wipe your face of the monster's mind-boggling goop.
                            Still, this isn't quite over yet.
                            Hell-bent on revenge, or so you assume, the monstrosity assails you, flinging multiple thorn-covered appendages your way.
                            You duck, bob and weave to avoid most of the initial onslaught, but as one of the tendrils just [i]barely[/i] grazes your arm,
                            the resulting scratch acts like a signal, telling you to [b]get the hell out of there[/b]. 
                        [/p]
                        [p]
                            You quickly snag your ${global.kobold.inventory.createItemWithTooltip(new WoolSweater())} off of the ground,
                            before turning around and [b]bolting[/b] out of the small forest clearing.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.unknown.pry.bite.continued();
        var choice = `<div class="choicecontainer">
                        <button class="button inlinechoice ${disabled ? "selected" : ""}" id="${continueId}" ${disabled ? "disabled" : ""}>
                            Continue
                        </button>
                      </div>`;
        return choice;
    }
    
    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.unknown.pry.bite.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "forestUnknownBite";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.unknown.pry.stay.get() !== ForestUnknownStayStillChoice.BITE) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += next.build();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.unknown.pry.stay.get() !== ForestUnknownStayStillChoice.BITE) {
            return;
        }
        
        next.registerListeners();

        if (ctrl.unknown.pry.bite.continued()) {
            return;
        }

        registerContinueListener();
    };
}
