/**
 * Item get section of Varanar, Afternoon Three.
 * @param {AfternoonThreeParlorController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeParlorFreeAccept(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeParlorKillFreeChoice.ACCEPT;
    var reqController = ctrl.killFree;
    var subController = ctrl.preContinue;
    var changeController = ctrl.killFreeAccept;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new AfternoonThreeParlorFreeAcceptLeave(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.parlorInjured = true;
        var arms = global.kobold.history.shared.varanar.dayThree.afternoon.parlorArmMassage;
        var back = global.kobold.history.shared.varanar.dayThree.afternoon.parlorBackMassage;
        var toReturn = `[p]
                            Some [i]aftercare[/i], huh?
                            You shoot the red kobold a lecherous smile.
                            Sure, you'd [b]love[/b] that.
                            You give her a suave wink.
                        [/p]`;

        if (arms) {
            toReturn += `[p]
                            "[color=bred]Very well then.
                            Stick out your arm, and close your eyes.[/color]"
                            Wait, she intends to do this [i]here[/i]?
                            In front of the others?
                            Oh.
                            [b]Oh.[/b]
                            She wants to give you some [i]actual[/i] massage-aftercare.
                            You thought she wanted to --
                            Judging by her unamused stare, you wisely drop your thinking out loud.
                            Instead, you comply with her wishes, closing your eyes and sticking one of your arms.
                        [/p]
                        [p]
                            [big][b]CRACK[/b][/big]
                        [/p]
                        [p]
                            Immense [b]pain[/b] floods your mind, so much of it that you can't help but [b]scream[/b] out in agony.
                            Opening your eyes, you witness your arm bending [b]the wrong way[/b]!
                            "[color=bred]He was [b]MINE[/b] to kill![/color]"
                            You clutch your elbow, feeling woozy, your sight growing dark.
                            "[color=bred]You [b]ROBBED[/b] me of the chance to earn my honor back![/color]"
                        [/p]
                        [p]
                            As if to add insult to injury, Red harshly slaps you across the face.
                            You barely even feel your cheek sting, the overbearing torment permeating from your dislocated arm fully eclipsing it.
                            Your mind can't handle this.
                            Your legs feel weak.
                            You collapse to the floor, and pass out.
                        [/p]`;
        } else if (back) {
            toReturn += `[p]
                            "[color=bred]Very well then.
                            Turn around, and close your eyes.[/color]"
                            Wait, she intends to do this [i]here[/i]?
                            In front of the others?
                            Oh.
                            [b]Oh.[/b]
                            She wants to give you some [i]actual[/i] massage-aftercare.
                            You thought she wanted to --
                            Judging by her unamused stare, you wisely drop your thinking out loud.
                            Instead, you comply with her wishes, closing your eyes and turning your back to her.
                        [/p]
                        [p]
                            [big][b]CRACK[/b][/big]
                        [/p]
                        [p]
                            Immense [b]pain[/b] floods your mind, so much of it that you can't help but [b]scream[/b] out in agony.
                            She [b]karate-chopped[/b] you straight in the [b]spine[/b]!
                            You can't feel [b]anything[/b] below your waist!
                            You collapse to the ground, your unresponsive legs no longer able to carry you.
                            "[color=bred]He was [b]MINE[/b] to kill![/color]"
                            You feel around your back.
                            There's a [b]lump[/b] around halfway up your spine.
                            "[color=bred]You [b]ROBBED[/b] me of the chance to earn my honor back![/color]"
                        [/p]
                        [p]
                            As if to add insult to injury, Red harshly [b]kicks[/b] your legs, but you can't even feel them.
                            They're completely numb.
                            Your mind can't handle this.
                            Your sight goes black.
                            You pass out on the floor.
                        [/p]`;
        } else {
            toReturn += `[p]
                            "[color=bred]Very well then.
                            Stick out your foot, and close your eyes.[/color]"
                            Wait, she intends to do this [i]here[/i]?
                            In front of the others?
                            Oh.
                            [b]Oh.[/b]
                            She wants to give you some [i]actual[/i] massage-aftercare.
                            You thought she wanted to --
                            Judging by her unamused stare, you wisely drop your thinking out loud.
                            Instead, you comply with her wishes, closing your eyes and sticking out your foot.
                        [/p]
                        [p]
                            [big][b]CRACK[/b][/big]
                        [/p]
                        [p]
                            Immense [b]pain[/b] floods your mind, so much of it that you can't help but [b]scream[/b] out in agony.
                            In the flash of an eye, she stepped on your foot to hold it down,
                            and then [b]threw[/b] you to the ground sideways, twisting and [b]dislocating[/b] your foot!
                            Opening your eyes, you can see it stand crooked.
                            Your very [b]bones[/b] grind against one another as you attempt to [b]move[/b] it!
                            "[color=bred]He was [b]MINE[/b] to kill![/color]"
                            It [b]hurts[/b]!
                            "[color=bred]You [b]ROBBED[/b] me of the chance to earn my honor back![/color]"
                        [/p]
                        [p]
                            As if to add insult to injury, Red harshly [b]kicks[/b] your stomach, but the pain is [b]nothing[/b] compared to your foot.
                            Your mind can't handle this.
                            Your sight goes black.
                            You pass out on the floor.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        global.ui.applyTheme("varanar_indoor_knockout");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
