/**
 * Knockout section of Varanar, Afternoon Three.
 * @param {AfternoonThreeParlorController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeParlorCutRopesSucceed(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.preMasseuse;
    var changeController = ctrl.cut;

    var autoContinue = true;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.masseuse;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            These ropes don't look so tough.
                            You reckon you can cut them using your sharp claws.
                            Wriggling around your hand, you inch your restraints upwards ever so slightly.
                            Now if only you can reach your wrist with your claws, you'll be able to slice the rope and get out of here!
                        [/p]
                        ${global.ui.condSucc(`Agility greater than 5`)}
                        [p]
                            You expertly curl your wrist,
                            angling it in such a way that the claw at the end of the longest of your four fingers can reach the rope, with half an inch to spare!
                            Perfect!
                            Your superior agility saves the day once more.
                            But you're not out of the woods yet.
                            You still need to [i]sever[/i] the rope.
                        [/p]
                        ${global.ui.condSucc(`Strength greater than 5`)}
                        [p]
                            You frantically begin to grind your sharp claw against the cord,
                            but this kind of rope in particular seems a lot more [b]firm[/b] than the regular stuff.
                            Like the kind used at the riverside docks, to tie boats to the piers.
                            While at first, your claw seems ineffective against the thick fibers of the strong rope,
                            after about a minute of trying, you appear to have made a gash!
                        [/p]
                        [p]
                            Perfect!
                            You keep on cutting until you reach about halfway through the rope, several strands breaking off.
                            With the cord weakend, you stop slicing, and instead firmly [b]yank[/b] it,
                            the rope breaking off around where you slice it, freeing your hand!
                        [/p]
                        [p]
                            With one arm free, you have no trouble escaping from the rest of your bondage.
                            You rid yourself of the last bit of rope still dangling off your wrist, and sneak over to one of the two doors.
                            Opening it, you discover that the room you were in was adjacent to the massage room.
                            Orange is tidying up the place, sweeping the floor, probably removing any trace that were ever even here.
                            As if anyone would come looking for [i]you[/i].
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
