/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyBargain(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyApproachChoice.BARGAIN;
    var reqController = ctrl.screamApproach;
    var subController = ctrl.bargain;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";
    var fourthId = arguments.callee.name + "ButtonFour";

    var firstNext = new AfternoonThreeRubyKind(ctrl);
    var secondNext = new AfternoonThreeRubyKiss(ctrl);
    var thirdNext = new AfternoonThreeRubyPanties(ctrl);
    var fourthNext = new AfternoonThreeRubyBody(ctrl);

    var firstChoice = AfternoonThreeRubyBargainChoice.WORDS;
    var secondChoice = AfternoonThreeRubyBargainChoice.KISS;
    var thirdChoice = AfternoonThreeRubyBargainChoice.PANTIES;
    var fourthChoice = AfternoonThreeRubyBargainChoice.BODY;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            You find it hard to [b]face[/b] the dragoness' glaring gaze.
                            Like you can feel her staring into your very soul.
                            You find yourself averting your eyes a lot, fidgeting about out of sheer nervousness.
                            "[color=cyan]Well, what's the holdup?[/color]" the lady speaks, in a bossy, commanding tone.
                            "[color=cyan]I gave you an [b]order[/b], you [b]wretch[/b]![/color]"
                        [/p]
                        [p]
                            A lie.
                            You need to come up with a lie.
                            Something that'll give you a few minutes to think of things to bargain for.
                            You meekly explain to the dragoness that you don't quite [i]have[/i] her locket, but you [i]might[/i] know where it is.
                            The thief that stole from her bumped into you while running away, and you saw him stash the pendant in-
                        [/p]
                        [p]
                            Before you can finish your explanation, 
                            the chubby lady rudely interrupts you:
                            "[color=cyan]Well then, what are we waiting for?!
                            Guide me there at once, you [b]peasant[/b]![/color]"
                        [/p]
                        [p]
                            Her wish is your command.
                            You turn around, and go back the way you came, the dragoness following close behind you.
                            "[color=cyan]Ugh, this place [b]sickens[/b] me!
                            How you kobolds manage to live in such squalor is beyond me.[/color]"
                            You try to explain that [i]you[/i] personally [b]don't[/b] live here,
                            but you get cut off by an exasperated sigh.
                            "[color=cyan]I didn't ask you for your life story.[/color]"
                        [/p]
                        [p]
                            Instead of allowing you to speak [b]at all[/b],
                            she continues to rant on about how much she dislikes this neighbourhood and the kobolds that inhabit it.
                            You bite your tongue, refraining from telling her that if she hates it so much here,
                            she shouldn't have come to begin with.
                            Other kobolds overhearing her words leer at the two of you.
                            Like she's oblivious to the dangers of pissing off the locals in a bad part of town.
                            You feel kind of [i]unsafe[/i] walking next to her.
                        [/p]
                        [p]
                            Luckily, it only takes a few minutes for you to arrive at the alley once more.
                            The two of you enter the abandoned mini-street.
                            About halfway through, you come to a halt, and point to one of the decrepit,
                            decaying, long-deserted hovels and shacks making up the claustrophobically close walls of the alley.
                            You claim that's where the locket was hidden.
                        [/p]
                        [p]
                            "[color=cyan]So, it's in there, then?![/color]" the dragoness asks in an impatient, upset voice.
                            "[color=cyan]I'm [b]sick[/b] and [b]tired[/b] of this place.
                            Go in there and get it for me, so I can [b]leave[/b] already.
                            And be quick about it, will you?![/color]"
                            You believe [b]this[/b] would be a good time to bring up your [i]reward[/i] for helping her.
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            The dragoness has a haughty look on her face,
                            like she's on top of the world, and no one can tell her otherwise.
                            But she's not in her castle, where she can reign over servants while acting all high and mighty.
                            She's in the midst of the kobold district.
                            [b]Your[/b] kind rules here, [b]not[/b] hers.
                            Still, you remain as nice as you possibly can, giving the lady a small, forced smile.
                        [/p]
                        [p]
                            Your apparent kindness seems to take the wind off her sails a tad, her dignified face relaxing slightly.
                            "[color=cyan]Hmph.
                            Someone in this [b]dump[/b] of a neighbourhood with some manners, for a change.
                            Lead me to my locket, knave.[/color]"
                            Without breaking your smile, you explain to her that sure:
                            you can do that.
                            You had a bit of a [i]bump[/i] with the thief not too far from here,
                            and then you witnessed the lowlife [b]stashing[/b] the locket in an abandoned building.
                        [/p]
                        [p]
                            A lie, but you need more time to think of things to bargain for.
                            "[color=cyan]Well then, why didn't you retrieve it after the thief left?
                            Why did you leave my locket is such an [i]unwholesome[/i] place?!
                            Someone else might have taken it by now![/color]"
                            Even as she speaks, the dragoness fearfully gazes around, seeing not kobolds and their pets, but [b]vicious[/b] attack dogs,
                            cats trained to [b]kill[/b], and tiny knife-wielding lizards itching to stab her guts.
                        [/p]
                        [p]
                            Noticing the lady panic, you reassure her by saying her locket was ditched in an alleyway that nobody really visits.
                            You're [b]very[/b] certain that it's still there.
                            Besides, you were scared you'd get punished if you even dared to [b]touch[/b] something that clearly belonged to a [b]noble lady[/b].
                            Bullseye.
                            You're good at lying.
                        [/p]
                        [p]
                            "[color=cyan]I might have made an exception, for a kobold like you that [b]knows its place[/b].
                            I do suppose you did the right thing, but I hope for your sake that it's still there.[/color]"
                            Once again, you assure the her that it [b]will[/b] be,
                            and you begin to guide the chubby dragoness back down the way you came.
                        [/p]
                        [p]
                            She keeps talking about how none of this would have happened if a kobold hadn't stolen her necklace to begin with.
                            You half-heartedly argue that at least another kobold, being [b]you[/b], is trying to fix the situation.
                            Surely that has to count for something, right?
                            The lady doesn't seem very impressed.
                        [/p]
                        [p]
                            After a few minutes of walking, you arrive back at the alleyway.
                            The two of you enter the abandoned mini-street.
                            About halfway through, you come to a halt, and point to one of the decrepit,
                            decaying, long-deserted hovels and shacks making up the claustrophobically close walls of the alley.
                            You claim that's where the locket was hidden.
                        [/p]
                        [p]
                            "[color=cyan]So, it's in there, then?[/color]" the dragoness asks in an impatient, upset voice.
                            "[color=cyan]This place is a [b]dump[/b].
                            I want to [b]leave[/b] as soon as I possibly can.
                            Be a dear and go fetch my locket from within, will you?
                            And be quick about it, before anyone sees me in a filthy alleyway with [i]you[/i].[/color]"
                            You believe [b]this[/b] would be a good time to bring up your [i]reward[/i] for helping her,
                            and for [b]tolerating[/b] that last remark.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            It's almost surprising how quickly her anger fades when your eyes meet hers.
                            She ogles you up and down, taking in your pleasing presence.
                            She looks confused, almost as though she was expecting you to be some [b]ruffian[/b],
                            instead of the fine-looking kobold that you are.
                            She seems a little [i]naive[/i] when it comes to kobolds, but you're not going to say that to her face.
                        [/p]
                        [p]
                            "[color=cyan]Nevermind all that yelling.[/color]" she corrects herself, without uttering an outright apology.
                            "[color=cyan]I'm just a bit [i]tense[/i].
                            That locket is a [b]very[/b] important item to me, and I'd like it back as soon as possible.[/color]"
                            Oh dear.
                            With the dragoness' sudden change of heart,
                            you almost start second-guessing your decision to [i]make her pay[/i] to get her belongings back.
                        [/p]
                        [p]
                            Needing a moment to think things through,
                            you recount the tale of how you met the thief in an alleyway not too far from here.
                            He bumped into you, a small [i]struggle[/i] ensued,
                            and amidst the [b]chaos[/b] and [i]confusion[/i], the locket ended up being tossed into the open window of an abandoned home.
                            You managed to chase the scoundrel off, and before recovering the valuable trinket,
                            you went in search of its [b]stunning[/b] mistress, first.
                        [/p]
                        [p]
                            Your flattery seems [b]very[/b] effective.
                            Your words make the lady blush.
                            "[color=cyan]Well, if you put it like [i]that[/i],
                            I suppose I owe you my gratitude.
                            But...why did you leave my locket unattended?
                            What if someone else saw where it went, and took it?[/color]"
                        [/p]
                        [p]
                            You assure the dragoness that the alleyway was completely empty, and has probably been abandoned for [b]years[/b].
                            "[color=cyan]Very well.
                            Given the [i]nature[/i] of this neighbourhood, I can understand why you didn't return it right away.
                            You did a good deed, which is rare for your kind.
                            Very commendable.
                            Do you think you could take me to my locket?[/color]"
                        [/p]
                        [p]
                            You mention that [i]was[/i] the plan, before casually reaching out, grabbing the lady's hand.
                            The dragoness' blush intensifies tenfold.
                            Together, holding hands, you begin to walk down the way you came,
                            leading her towards the alleyway where the thief bumped into you.
                            The odd pair around, you garner [b]a lot[/b] of attention from people in the streets,
                            but you keep her attention fixed to [b]you[/b] by exchanging smalltalk,
                            preventing her from worrying about being seen by a lowly kobold such as yourself.
                        [/p]
                        [p]
                            For a moment, it almost feels like you're taking a stroll with your [b]girlfriend[/b].
                            The dragoness truly opens up to you.
                            She tells you about her father, a mighty and powerful black dragon who is wealthier than everyone in Varanar combined.
                            You wonder what profession earned him that wealth, but the lady conveniently doesn't mention that, and it would be [i]rude[/i] to pry.
                        [/p]
                        [p]
                            After a few minutes of walking, you arrive back at the alleyway.
                            The two of you enter the abandoned mini-street.
                            About halfway through, you come to a halt, and point to one of the decrepit,
                            decaying, long-deserted hovels and shacks making up the claustrophobically close walls of the alley.
                            You claim that's where the locket ended up.
                        [/p]
                        [p]
                            The dragoness pulls her hand away from yours, wiping her palm on her dress.
                            "[color=cyan]So, it's in there, then?[/color]" the dragoness asks, clearly disgusted by her surroundings.
                            "[color=cyan]I'm [b]not[/b] going in there.
                            There's probably [b]spiders[/b] and [b]bugs[/b].
                            Nothing fit for a princess![/color]"
                            A princess, huh?
                            So that must mean her father is...
                            "[color=cyan]My kind helper in need, could I trouble you one final time?
                            Go in there and fetch the locket for me!
                            I beg of you![/color]"
                            You believe [b]this[/b] would be a good time to bring up your [i]reward[/i] for helping her.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Kind words</button>`;

        var tooltip = global.parser.parse(`You need no compensation, apart from maybe a few words to stroke your ego.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 195px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>A kiss</button>`;

        var tooltip = global.parser.parse(`Pucker up. If she wants the locket, then you want a kiss.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Her panties</button>`;

        var tooltip = global.parser.parse(`Surely the locket is worth more than her underwear, right?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 150px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFourthChoice() {
        var failedCheck = ctrl.misc.exertion() > 69;
        var disabled = subController.has() || failedCheck ? "disabled" : "";
        var isSelected = subController.get() === fourthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fourthId}" ${disabled}>Her body</button>`;

        var tooltip = global.parser.parse(`She wants her locket. You want to fuck.`);
        if (failedCheck) {
            tooltip = global.parser.parse(`You are too sexually exerted to ask the dragoness for sex.`);
        }
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You want:</div>`;
        choice += `<div class="choicerow" style="margin-bottom: 10px;">`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        choice += `<div class="choicerow">`;
        choice += buildThirdChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildFourthChoice();
        choice += `</div>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId), $("#" + thirdId), $("#" + fourthId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFourthListener() {
        $("#" + fourthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(fourthChoice);
            loadNextPart(fourthNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if(global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3) {
            global.ui.imageBackground.show("scenes/Varanar/DayThree/AfternoonThree/ruby/img/Dragon_lead.png");
        }
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        part += fourthNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();
        fourthNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
        registerFourthListener();
    };
}

var AfternoonThreeRubyBargainChoice = {
    WORDS: 1,
    KISS: 2,
    PANTIES: 3,
    BODY: 4
};
