/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeInvestigateScream(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.scream;
    var changeController = ctrl.scream;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new AfternoonThreeRubyApproach(ctrl);
    var secondNext = new AfternoonThreeInvestigateScreamLeave(ctrl);

    var firstChoice = AfternoonThreeInvestigateScreamChoice.APPROACH;
    var secondChoice = AfternoonThreeInvestigateScreamChoice.LEAVE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var his = ctrl.misc.baseGender() === GenderEnum.MALE;
        var saphira = global.kobold.history.shared.dragonessPrincess.relation !== DragonessPrincessEnum.UNMET;
        global.kobold.history.shared.varanar.dayThree.afternoon.ruby = true;
        global.kobold.history.shared.varanar.dayThree.afternoon.brownMale = his;
        global.kobold.history.shared.varanar.dayThree.afternoon.brownFemale = !his;
        var toReturn = `[p]
                            You hurry towards the source of the noise, pushing your way through the crowded, narrow streets.
                            The twisting maze of sharp corners,
                            dark dead-ends and concealed pathways that make up this entire neighbourhood almost cost you your sense of direction,
                            but a second distressed shout helps you orient yourself anew.
                            While struggling with navigating the entangled web of dry, muddy walkways you'd barely even consider to be [i]roads[/i],
                            you [b]are[/b] getting closer to your goal.
                        [/p]
                        [p]
                            The kobold-packed streets suddenly give way to a jarring [i]emptiness[/i].
                            You find yourself in a pitch-black alleyway connecting two roads, with not a single other living being -- that you can see -- in it.
                            You almost feel like finding a way [i]around[/i] what seems to be a perfect place for a [b]trap[/b] or an [b]ambush[/b],
                            but despite the rational part of your brain begging you [b]not[/b] to skip through here,
                            someone's [b]life[/b] might be at stake.
                            Every second counts.
                            And you're not going to let a stranger [b]die[/b] because you were [b]scared[/b] of an [b]empty alleyway[/b].
                        [/p]
                        [p]
                            You press on, jogging through the decrepit side-street, constantly wary of the various abandoned buildings on either side.
                            While excellent hiding spots for any would-be thieves, thugs or even [b]assassins[/b],
                            luckily for you, this place [i]actually[/i] seems deserted.
                        [/p]
                        [p]
                            Nearing the other end of the alleyway,
                            you hear a racket around the corner.
                            A pot breaking, a cat angrily hissing, and some upset yelling about [i]being more careful[/i].
                            Suddenly, you become aware of uncharacteristically [b]loud[/b] footsteps headed your way,
                            like those of a thief too desperate to [b]escape[/b] from someone or [i]something[/i] to hide ${his ? `his` : `her`} presence.
                            You know that noise all too well.
                            You've been in that same situation, after all.
                        [/p]
                        [p]
                            Ere you get a chance to reminisce, a brown-scaled kobold turns the corner, [b]bolting[/b] into the alleyway.
                            It's too late for you to jump out of the way.
                            You have no chance to avoid ${his ? `him` : `her`}.
                            The running lizard [b]crashes[/b] into you, bumping you so hard ${his ? `he` : `she`} nearly knocks you off your feet!
                            You clamp onto ${his ? `him` : `her`} in a desperate attempt to stay upright.
                            ${his ? `He` : `She`} does the same, grabbing you by your shoulders, sending the two of you into an almost dance-like spin.
                        [/p]
                        [p]
                            After a few disorienting twirls, the brown kobold and you both come to a halt.
                            Dizzy from the spinning, you shake your head to snap out of your daze.
                            You don't get a chance to scold ${his ? `him` : `her`}, to apologize, or even to ask what's going on.
                            ${his ? `He` : `She`} hastily shoves something small into your hands, which you instinctively clutch.
                        [/p]
                        [p]
                            "[color=brown]Sorry about that, here you go, let's be friends, see you again, I'm outtah here![/color]"
                        [/p]
                        [p]
                            Your head still spinning, you don't even properly [b]understand[/b] what's going on.
                            Before you've managed to fully parse what ${his ? `he` : `she`} hastily said,
                            the brown kobold breaks away from you, and continues ${his ? `his` : `her`} careless sprinting,
                            running out of the other side of the alleyway,
                            disappearing into the kobold district, leaving you dazed, confused, upset and slightly [i]enamored[/i]?
                            Almost like you've met [b]yourself[/b], but colored brown instead of green.
                            The way ${his ? `he` : `she`} held your shoulders felt almost [i]romantical[/i].
                            And it might have been, had ${his ? `he` : `she`} not [b]rammed[/b] into you like a clueless [b]oaf[/b].
                        [/p]
                        [p]
                            Once more alone, it is only then that you realize ${his ? `he` : `she`} handed you something.
                            You look down, to find a fancy ${global.kobold.inventory.createItemWithTooltip(new DragonLocket())} in the palm of your hand.
                            Old, but well-kept and polished to make it shiny and sparkly.
                            Like a beacon of light in this dark and dreary alleyway, reflecting what little sunlight filters through the rooftops.
                            You flick the locket open, to reveal the imposing face of some royal-looking black dragon guy, painted with utmost detail and care.
                            The mini-painting might be worth quite a few coins by itself.
                        [/p]
                        [p]
                            Another shout tears you from your thoughts of wealth and nobility.
                            Louder, this time.
                            You must be drawing near!
                            You close the locket and take it with you,
                            jogging out into the street.
                            The brown kobold definitely came this way.
                            A shopkeeper is sweeping together the remains of one of his stalled-out pots,
                            undoubtedly broken by the careless rascal.
                        [/p]
                        [p]
                            Pressing onwards, you get close enough to the source of the ruckus to discern the words being screamed,
                            hysterical shouting dying out into loud and angry yelling, by a distinctly feminine voice.
                            "[color=cyan]Y-you lowborn scum!
                            Thieves and whores a-and [b]cattle[/b], the lot of you!
                            Bring it back to me now or -- or I'll make you [b]suffer[/b]!
                            I swear!
                            I'll get my father to torch this place to the ground![/color]"
                        [/p]
                        [p]
                            You carefully peek around the last corner separating you from the damsel in distress.
                            A chubby, red-scaled dragoness is [b]screaming[/b] her frustrations out to the world.
                            It looks like she's fallen down recently, judging by the mud-stains on her fancy blue dress,
                            but even through her teary eyes, you can tell that she's trying to pretend that her scraped knees [b]aren't[/b] hurting.
                            Typical, stuck-up draconic pride.
                        [/p]
                        [p]
                            None of the kobolds crowding the street appear to pay her much mind.
                            Everyone looks to be [b]ignoring[/b] her.
                            Like they know her threats have no validity.
                            What's a lone dragoness to do against a horde of kobolds?
                            Nothing, that's what.
                            Still, you find it kind of odd.
                            She doesn't belong here.
                            She sticks out like a sore thumb.
                            And you're the only one who seems even remotely interested in her.
                            Perhaps it's normal around these parts to completely disregard non-kobolds?
                        [/p]
                        [p]
                            "[color=cyan]I want my locket back [b]right now[/b]!
                            Or I'll have the guards come in here and [b]butcher[/b] every last one of you!
                            You have [b]no rights[/b]!
                            I'll have you all [b]executed[/b]!
                            [b]Flayed alive![/b][/color]"
                        [/p]
                        [p]
                            A resident of one of the taller buildings, a few floors high, seems to have had enough of the public disturbance.
                            Standing on his rickety balcony, he tosses down the first plant-pot he managed to get his hands on,
                            which luckily misses the dragoness by an inch, shattering against the ground right next to her, breaking into a million little pieces.
                            "[color=purple]Shut the hell up! I have guard duty at the brothel tonight! I'm trying to sleep here![/color]" he shouts back at her.
                        [/p]
                        [p]
                            The chubby dragoness glares upwards, loudly hurling profanities at the kobold that almost injured her.
                            She's clearly on the brink of bursting into tears, but simply refuses to show any signs of weakness in front of [i]your kind[/i].
                            ${saphira ? `Almost reminds you of that other dragoness you met in the forest. You know, the one you saw earlier today.` : ``}
                        [/p]
                        [p]
                            Wait a minute, was she talking about some kind of [i]locket[/i]?
                            Like, maybe, the one that brown-scaled doofus handed to you?
                            Oh.
                            [b]Oh.[/b]
                            You figuratively piece the puzzle together.
                            The kobold must have stolen the locket from the chubby dragoness,
                            and then fled into the kobold district.
                            The dragoness ran after ${his ? `him` : `her`}, tripped somewhere along the way, and lost track of ${his ? `him` : `her`}.
                            The kobold thought ${his ? `he` : `she`} was still being pursued, and tried to pass the heat onto you.
                        [/p]
                        [p]
                            The most noble thing to do would be, of course, to return the locket.
                            But you [i]are[/i] still in debt.
                            And besides being a little [i]scuffed[/i], the dragoness looks like she can afford a dozen of these.
                            Plus, with the way she's talking about having kobolds [b]executed[/b] and [b]flayed[/b],
                            you're not really sure you even [b]want[/b] to return it.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Approach</button>`;

        var tooltip = global.parser.parse(`You bet the locket belongs to her. It's only right that you return it.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Leave</button>`;

        var tooltip = global.parser.parse(`This thing looks pretty valuable. Finders, keepers. It's yours now.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.show("scenes/Varanar/DayThree/AfternoonThree/ruby/img/Dragon_angery.png");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var AfternoonThreeInvestigateScreamChoice = {
    APPROACH: 1,
    LEAVE: 2
};
