/**
 * Arrival section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeKnights(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new MorningThreeEggs(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dragonessRelation = global.kobold.history.shared.dragonessPrincess.relation;
        var toReturn = `[p]
                            That was the worst night you think you've [b]ever[/b] had.
                            With dawn breaking, the streets are slowly filling with people.
                            You're so sleepy, you could drop to the ground and instantly start slumbering,
                            but after last night, you fear what would happen to you if you did.
                            Your tired feet carry you back towards the plaza.
                        [/p]
                        [p]
                            Nearing the grand avenue, you hear the distinct noise of a bunch of horses trotting down the road.
                            Mounted guardsmen?
                            This early?
                            And [i]so many[/i] of them?
                            No way.
                            Your inquisitiveness energizing you, you jog towards the display.
                            Arriving at the avenue proper, you see a column of heavily armed and armoured [b]mounted dragon knights[/b] strutting into town.
                            At the head of the military formation rides a blue-scaled maiden, the only one [i]not[/i] wearing armor.
                        [/p]`;

        if (dragonessRelation === DragonessPrincessEnum.UNMET) {
            toReturn += `[p]
                            The column passes by without paying you any mind.
                            They head past the marketplace, presumably towards the keep.
                            You don't know much about politics, but you doubt a group of dragon knights showing up at the human capital is a [i]good[/i] thing.
                            Unless they were just escorts, of course.
                            The roads [i]are[/i] pretty unsafe these days, especially for a dragoness as pretty as the one you just saw.
                        [/p]`;
        }

        if (dragonessRelation === DragonessPrincessEnum.UNHELPED) {
            toReturn += `[p]
                            Wait a minute.
                            Isn't the [i]maiden[/i] that one dragoness you saw in the woods?
                            The one you kind of [i]didn't help[/i] when she was getting [b]raped[/b].
                            You can't quite recall whether or not she saw you there, but you believe it'd be best for the both of you if she [i]doesn't[/i] see you now.
                            Y'know, to prevent any [i]unfortunate recollections[/i] that might make her want to tell her knightly friends to [b]cut you down[/b].
                        [/p]
                        [p]
                            Luckily for you, the column passes by without paying you any mind.
                            They head past the marketplace, presumably towards the keep.
                            Part of you is glad to see that the dragoness made it out of the woods alive.
                            But then again, if she [i]does[/i] recall you being present during her [i]unpleasant run-in[/i],
                            then perhaps her being in the same town as you might be a [b]bad[/b] thing.
                        [/p]`;
        }

        if (dragonessRelation === DragonessPrincessEnum.HELPED) {
            toReturn += `[p]
                            Wait a minute.
                            Isn't the [i]maiden[/i] that one dragoness you saw in the woods?
                            You know, the one you couldn't quite [i]prevent[/i] from getting abused by that kobold gang.
                            At least you helped her out afterwards.
                            Surely that counts for something, right?
                        [/p]
                        [p]
                            You try to draw the lady's attention, but the column passes by without paying you any mind,
                            stepping horse-hooves preventing you from getting [i]too[/i] close.
                            They head past the marketplace, presumably towards the keep.
                            At least you're glad to have seen the dragoness again.
                            Now you know she made it out of the woods alive, if not completely [i]untouched[/i].
                        [/p]`;
        }

        if (dragonessRelation === DragonessPrincessEnum.SLOPPY_SECONDS) {
            toReturn += `[p]
                            Wait a minute.
                            Isn't the [i]maiden[/i] that one dragoness you, uh, [i]met[/i] in the woods?
                            The one you kind of [i]didn't help[/i] when she was getting [b]raped[/b].
                            And then you had some [i]fun[/i] with her cum-oozing body while she was nigh-catatonic.
                            Oh dear.
                            You can't quite recall whether or not she was [i]conscious[/i] enough to remember your face,
                            but you believe it'd be best for the both of you if she [i]doesn't[/i] see you now.
                            Y'know, to prevent any [i]unfortunate recollections[/i] that might make her want to tell her knightly friends to [b]cut you down[/b].
                        [/p]
                        [p]
                            Luckily for you, the column passes by without paying you any mind.
                            They head past the marketplace, presumably towards the keep.
                            Part of you is glad to see that the dragoness made it out of the woods alive.
                            But then again, if she [i]does[/i] recall what you did,
                            then perhaps her being in the same town as you might be a [b]bad[/b] thing.
                        [/p]`;
        }

        if (dragonessRelation === DragonessPrincessEnum.SAVED) {
            var dragonessSavedBy = global.kobold.history.shared.dragonessPrincess.savedBy;
            var needle = ctrl.misc.hasMisc(ItemEnum.GOLDENNEEDLE);
            var savedBy = ``;
            if (dragonessSavedBy === DragonessPrincessSavedBy.PAYING_GANG) {
                savedBy = `You paid off the gang harassing her.`;
            }
            if (dragonessSavedBy === DragonessPrincessSavedBy.SCARY_NOISE) {
                savedBy = `You scared off the gang harassing her.`;
            }
            toReturn += `[p]
                            Wait a minute.
                            Isn't the [i]maiden[/i] that one dragoness you [i]saved[/i] in the woods?
                            ${savedBy}
                            It is!
                            Saphira was her name, or so you believe.
                            She even gave you a
                            ${global.kobold.inventory.createItemWithTooltip(new GoldenNeedle())}${needle ? `, which you still have,` : ``} as a reward!
                            You're glad to see she made it out of the forest alive and well!
                        [/p]
                        [p]
                            You try to draw the lady's attention, but the column passes by without paying you any mind,
                            stepping horse-hooves preventing you from getting [i]too[/i] close.
                            They head past the marketplace, presumably towards the keep.
                            You feel kind of [i]bummed out[/i], first having been [i]declined[/i] as an escort,
                            and now getting flat-out [i]ignored[/i] by the princess,
                            but you suppose a little kobold like yourself doesn't matter much to a high and mighty woman like her.
                        [/p]`;
        }

        if (dragonessRelation === DragonessPrincessEnum.RAN_AWAY) {
            var tenpaw = global.kobold.history.shared.tenPawGang.relation;
            var raped = tenpaw === TenPawGangEnum.RELUCTANT_GANGBANG || tenpaw === TenPawGangEnum.GANGRAPE;
            toReturn += `[p]
                            Wait a minute.
                            Isn't the [i]maiden[/i] that one dragoness you [i]kind of[/i] saved in the woods?
                            You know, the one that [i]ran away[/i] while you were discussing things with the kobold gang.
                            At least you [i]helped her[/i] escape.
                            Surely that counts for something, right?
                        [/p]
                        [p]
                            You try to draw the lady's attention, but the column passes by without paying you any mind,
                            stepping horse-hooves preventing you from getting [i]too[/i] close.
                            They head past the marketplace, presumably towards the keep.
                            At least you're glad to have seen the dragoness again.
                            Now you know she made it out of the woods alive${raped ? `, in part due to the [b]hell[/b] you went through` : ``}.
                        [/p]`;
        }

        toReturn += `   [p]
                            You follow the trail of the knights, not to chase after them, but simply to make your way back to the town square.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.knights.continued() ? "disabled" : "";
        var isSelected = ctrl.knights.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.knights.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        ctrl.bgm.loop();
        global.ui.applyTheme("varanar_morning");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.knights.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        next.registerListeners();

        if (ctrl.knights.continued()) {
            return;
        }

        registerNextListener();
    };
}
