/**
 * Throw one section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeThievery(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.thievery;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new MorningThreeKeepEgg(ctrl);
    var secondNext = new MorningThreeReturnEgg(ctrl);
    var thirdNext = new MorningThreeThrowEgg(ctrl);

    var firstChoice = MorningThreeThieveryChoice.KEEP;
    var secondChoice = MorningThreeThieveryChoice.RETURN;
    var thirdChoice = MorningThreeThieveryChoice.THROW;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.morning.thievingAttempt = true;
        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var Him = dick ? `Her` : `Him`;
        var her = Him.toLowerCase();
        var toReturn = `[p]
                            You [i]could[/i] use some cheering up after such a hellish night,
                            and you don't want to look [i]weird[/i] in front of your new friend.
                            Plus it'll be nice to get some [i]retribution[/i] on a non-kobold.
                            After all, knights are supposed to [b]punish[/b] evildoers,
                            and the bird on stage must have done [i]something[/i] to earn his place in the spotlight.
                            With an abundance of reasons to throw, and none to hold back, you decide to let loose and pelt away.
                        [/p]
                        [p]
                            With a small grunt, you chuck your first egg at the trapped avian.
                            The rotten would-be-breakfast soars through the air with a slight curve, before hitting the bird squarely in the face!
                            It cracks open, the disgusting goop contained within splattering all over the man's feathery face, most of the stuff flowing down along his beak.
                            Some of it manages to make its way into his mouth.
                            He gags, sputters and spits.
                            The cyan kobold burst out into laughter, and you join in.
                            "[color=cyan]Rotten like your wife's clutches![/color]"
                            ${She} turns to you.
                            "[color=cyan]Hit'em with the other one![/color]"
                        [/p]
                        [p]
                            You decline.
                            The man you're throwing at is [i]helpless[/i].
                            Bullying him may be fun, but you know first-hand that being on the receiving end is everything but.
                            Doing this, throwing these eggs, makes you no better than the humans and their ilk.
                            And while you [i]did[/i] let yourself go [i]a little[/i], you refuse to stoop yourself down to their level any further.
                        [/p]
                        [p]
                            You hold the rotten egg in-hand, and turn to face your new friend, just in time to witness ${his} hand reaching for your coin pouch.
                            ${She} immediately pulls back, but you are no fool.
                            In fact, as a thief, you've performed these kinds of scams yourself.
                            You demand to know what ${he} was reaching for.
                            "[color=cyan]J-just stretching my arms.[/color]" comes the stuttering reply,
                            a droplet of sweat running drown from the kobold's forehead, signalling ${his} nervousness.
                        [/p]
                        ${global.ui.condFail(`Charisma below 6`)}`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Keep it</button>`;

        var tooltip = global.parser.parse(`The egg could serve as a weapon. Keep it.`);

        if (ctrl.misc.weapon()) {
            tooltip += ` Your current weapon will be discarded.`;
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Return it</button>`;

        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var Him = dick ? `Her` : `Him`;
        var her = Him.toLowerCase();

        var tooltip = global.parser.parse(`Hand it back to the would-be-thief and send ${her} on ${his} way.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Throw it</button>`;

        var dick = ctrl.misc.dick();

        var tooltip = global.parser.parse(`Teach the thief a lesson ${dick ? "s" : ""}he won't soon forget.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader choicerow">What do you do with the egg?</div><br/>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.thievery.change();
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var MorningThreeThieveryChoice = {
    KEEP: 1,
    RETURN: 2,
    THROW: 3
};
