/**
 * Overdressed section of Varanar, Noon Three.
 * @param {VaranarSoupKitchenController} controller The Varanar, Noon Three controller.
 */
function VaranarSoupKitchenOverdressed(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.overdressed;
    var changeController = ctrl.overdressed;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new VaranarSoupKitchenAccuseSelector(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var clothes = ctrl.misc.bra() || ctrl.misc.shirt() || ctrl.misc.pants() || ctrl.misc.underwear();
        var toReturn = `[p]
                            Gathering your courage, you walk up to the door, and slowly push it open.
                            Despite taking little effort to move, it creaks loudly, alerting whoever may be inside to your presence.
                            Swallowing deeply, you step inside of the dilapidated building, and close the door behind you.
                        [/p]
                        [p]
                            You find yourself alone in a dusky room that has clearly seen better days.
                            Apart from the chairs and tables arrayed across the wooden floor, you'd say this almost looks like an abandoned [i]store[/i].
                            At least it's warm in here, so the soup kitchen can't be [i]completely[/i] deserted.
                            You figure the stove must be behind the mercantile countertop, but you're not tall enough to see.
                            To your left is a set of stairs which you figure must lead to the proprietor's [i]above-ground[/i] home.
                        [/p]
                        [p]
                            Suddenly, you hear movement above.
                            Footsteps.
                            No wait.
                            Clacking hooves?
                            "[color=ppink]Yeah, ah heard yah! I'ma comin'![/color]" a bass voice rings out from the second floor.
                        [/p]
                        [p]
                            Down the stairs comes storming a big, wet, outright [b]fat[/b] anthromorphic sheep,
                            his bloated, wool-covered belly jiggling with every step he takes,
                            soapy water dripping liberally from his fleece.
                            The man isn't wearing much besides a towel, tied snugly around his waist.
                            "[color=ppink]Can't a sheep take a fockin' bath wifout a beggar wanderin' in?![/color]"
                            At least you don't have to ask why he's wet and half-naked.
                            "[color=ppink]Well then, what'd ye want, yah skinky lizard?![/color]"
                        [/p]
                        [p]
                            The caprine comes to a rest merely a foot away from you, the wool on his big gut almost pressing into your snout.
                            You can't help but stare at his massive belly,
                            as you stammer out the dumbest question your mind could think of while looking at someone big enough to [b]eat[/b] you.
                            You ask whether or not the man [i]cooks[/i] kobolds here.
                            He leans over you threateningly, a droplet of water dripping from his chin down on top of your forehead.
                            Glaring at you, he responds to your question in a grim tone.
                            "[color=ppink]Aye, but only the ones that think they're funny.
                            Or the ones that [b]stare at mah belly[/b].[/color]"
                        [/p]
                        [p]
                            His words remind you that you [i]are[/i] still leering at his bulky lower body instead of looking the man in the eyes.
                            Correcting your mistake, you quickly stammer out a meek apology.
                            The sheep suddenly bursts out into laughter.
                            "[color=ppink]Hahahahaha!
                            Scared ye, didn't ah?
                            Only vegetarian meals here, [i]kuhbold[/i].
                            Us sheep, we cannae eat meat.[/color]"
                            You let out an uneasy chuckle, a disturbed smile forming on your face.
                            At least you won't be getting cut up and put into a stew today.
                        [/p]
                        [p]
                            You nervously ask the [i]chef[/i] if you could maybe, if at all possible, if it's not a bother, get something tiny to eat, perhaps?
                            You know you're [i]interrupting[/i] his bath-time, but you're kind of [b]starving[/b].
                            "[color=ppink]'Fraid not.[/color]" the caprine responds, with a hint of sadness in his voice.
                            "[color=ppink]I closed down shop yesterday.
                            Not enough money to pay rent for this shitehole.
                            I was half expectin' yah tah be here tah [b]kick me out[/b].[/color]"
                            Even his [i]endearing[/i] accent fails to mask the man's distress.
                        [/p]
                        [p]
                            The chubby sheep lets out a sigh, eyeing you up and down.
                            "[color=ppink]Fancy ${clothes ? `clothing` : `weapon`}.
                            Who'd ye steal that from?
                            Tell yah what, for a well-${clothes ? `dressed` : `armed`} lizard like you, I'll make an exception.
                            I've got some leftovers from yesterday.
                            Won't be warm, but it's better than nothin', aye?[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController.continue();
        }

        global.ui.applyTheme("hamlet_shop");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
