/**
 * Overdressed section of Varanar, Noon Three.
 * @param {VaranarSoupKitchenController} controller The Varanar, Noon Three controller.
 */
function VaranarSoupKitchenThreaten(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = VaranarSoupKitchenAccusedChoice.THREATEN;
    var reqController = ctrl.accused;
    var subController = ctrl.preContinue;
    var changeController = ctrl.threaten;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.apple;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var weapon = ctrl.misc.weapon();
        var toReturn = `[p]
                            You threaten him, boldly stating that he'd better go get you some soup and quick, [b]or else[/b].
                            ${weapon ? `You have a weapon, and you're not afraid to use it.` : `You may not have a weapon, but you can [b]rake[/b] him with your claws.`}
                            Unless the sheep is looking for [b]trouble[/b], he'd best get to serving you, and make it snappy.
                            He wouldn't want to get [b]killed[/b] the day after retirement, now would he?
                        [/p]
                        [p]
                            "[color=ppink]You?
                            Kill [b]me[/b]?
                            Don't make me [b]laugh[/b], [i]kuhbold[/i].[/color]"
                            You growl loudly, dropping into a combat stance to show the caprine how [b]serious[/b] you are.
                            Before you even have the chance to issue a final warning,
                            the palm of the fat sheep's hand [b]slams[/b] into your jaw,
                            the big man's slap strong enough to almost knock you off your feet.
                            You recoil, clutching your muzzle, on the verge of crying.
                            At first, you think he might have knocked out a tooth, but upon tongue-inspection, everything appears to be still in place.
                        [/p]
                        [p]
                            "[color=ppink]Do ye really think you're first lizard tah threaten meh?
                            I've dealt with far more imposin' [i]kuhbolds[/i] than you.
                            Smacked'em to hell and ba~ack, wrestled'em to the ground and made'em [b]beg[/b] for mercy.
                            What chance do [b]you[/b] stand against [b]me[/b]?
                            If ah shave the wool off mah body, arse to head, it'll form a pile bigger than you are!
                            Now, unless you want'ay get slapped again, get [b]out[/b] of mah soup kitchen.
                            We're [b]closed[/b].
                            [b]Forever[/b].[/color]"
                        [/p]
                        [p]
                            That being said, the fat sheep points towards the door.
                            You consider trying to fight him still, but he's right.
                            There's no point in getting the shit kicked out of you needlessly.
                            You simply aren't built to fight a man of his size.
                            Hanging your head, you walk out the door, back towards the market square.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
